# Задание 3

На машине `studX-net1` настройте доступ в интернет. В качестве шлюза используйте адрес `192.168.0.1`. 

1. Узнайте статус сервиса `systemd-networkd` 
```
# systemctl status systemd-networkd
```

2. Активируйте `system-networkd`, если он не активирован (disabled)
```
# systemctl enable systemd-networkd
```

3. Запустите `system-networkd`, если он не запущен (inactive, dead) 
```
# systemctl start systemd-networkd
```

4. Определите имя настраиваемого интерфейса (не loopback).
```
# ip link
```

5. Для настройки интерфейса `ens18` машины `stud1-net1` создайте или отредактируйте в каждой `/etc/systemd/network/ens18.network`.

конфигурация `ens18.network` машины `stud1-net1`
```
[Match]
Name=ens18

[Network]
Address=192.168.0.2/24
Gateway=192.168.0.1 
```

6. Перечитайте конфигурацию сети 
```
# networkctl reload
```

7. Проверьте доступность ip-адреса в сети internet
```
stud@stud1-net1$ ping 1.1.1.1
```

Наличие маршрута в интернет покажет команда 
```
> ip route
default via 192.168.0.1 dev ens18 ...
```
