# Задания

### Задание 1. Команды

0. Установите Debian с графической оболочкой и загрузитесь в неё. 
1. В консоли перейдите в уровень запуска `multi-user.target` без перезагрузки, а затем обратно `graphical.target`.
2. Перейдите в уровень запуска `multi-user.target` с перезагрузкой, а затем переключитесь в графическую оболочку обратно.
3. Выведите модуль, который активируется по-умолчанию.
4. Выведите возможные состояния модулей командой `systemctl --state=help`.
5. Найдите в man странице какие типы модулей есть в `systemd`.
6. Выведите список установленных модулей.
7. Деактивируйте сервис `timesyncd`.
8. Перезагрузите сервис `timesyncd`.
9. Выведите список модулей в памяти.
10. Проверьте, что сервис `timesyncd` активирован.
11. Выведите список зависимых модулей для сервиса `timesyncd`.
12. Выведите список сокетов в памяти.
13. Выведите список таймеров в памяти.
14. Проверьте статус сервиса `timesyncd`.
15. Проверьте, что сервис `timesyncd` активен.
16. Выведите список свойств модуля.
17. Выведите уровень логирования для сервиса `timesyncd`.
18. Перезагрузите конфигурацию systemd менеджера: перезапустите генераторы (`systemd.generator`), все модули и перестройте дерево зависимостей.
19. Какие префиксы можно использовать при указании исполняемых файлов в файлах `.service`.

### Задание 2. Конфигурация сервиса

Сконфигурировать `socks` прокси сервис, который:

* вызывает команду `ssh -N -D 0.0.0.0:80 localhost`,
* запускается после `network.target`,
* всегда перезагружается при завершении, но не чаще, чем 1 раз в 5 секунд,
* запуск проивзодится на уровне `multi-user.target`.

Проверьте работу прокси сервиса из браузера с помощью плагина `foxyproxy`.

Страницы документации man:
  - systemctl
  - systemd
  - systemd.unit
  - systemd.service
  - systemd.target
  - systemd.socket
  - systemd.exec
  - systemd.resource-control
  - networkctl
  - timedatectl