# Задания

### 1. Установка

Установите Docker на виртуальную машину

### 2. Базовые команды

1. Запустите Docker hello-world

2. Загрузите образ busybox с Docker Hub

3. Напечатайте 'Hello from busybox!', запустив контейнер на основе образа busybox с командой echo

4. Запустите контейнер с busybox в интерактивном режиме и напечатайте 'Hello, World!' изнутри. После этого завершите выполнение контейнера.

5. Запустите контейнер как в пункте 3, но присвойте ему имя.\
   После того, как его выполнение завершится, запустите его же - еще раз, по имени. Убедитесь что он выведет то же самое.

6. Создайте именованный контейнер как в пункте 3, но так, чтобы он не запустился сразу же. Запустите его руками.

7. Запустите контейнер с busybox, который каждую секунду печатает текущее время, но запустите его в отвязанном от терминала режиме.\
   Так чтобы он не печатал ничего вам на стандартный вывод. \
   Посмотрите логи этого контейнера, и убедитесь что он работает.

8. Выведите список всех контейнеров. Сначала работающих, потом - всех, даже остановленных. Потом - только остановленных.

9. Удалите все остановленные контейнеры, включая те, что так и не запустились, если такие были.

10. Приаттачьтесь к терминалу запущенного контейнера, который печатает текущее время каждую секунду, так чтобы увидеть поток этих строк.\
    В параллельном терминале, поставьте выполнение контейнера на паузу, но без его полной остановки.\
    Убедитесь что печать приостановилась.\
    Возобновите работу контейнера.\
    Сделайте детач терминала от контейнера, но так, чтобы он не остановился, а продолжил работу.\
    В конечном итоге остановите контейнер извне.

11. Создайте какой-либо текстовый файл.\
    Запустите контейнер с busybox в интерактивном режиме.\
    В отдельном терминале скопируйте файл внутрь контейнера, прямо в корневую директорию.\
    В терминале с интерактивным режимом - выведите содержимое файла на экран.\
    Пока что не останавливайте контейнер.

12. В терминале, отдельном от терминала контейнера с интерактивным режимом, сделайте листинг корневой директории контейнера.\
    Также, с помощью одной из команд Docker, выведите на экран список изменений в файловой системе контейнера по сравнению\
    с базовым образом.\
    После этого, в этом же терминале, удалите из контейнера скопированный туда файл.\
    Теперь интерактивный контейнер можно остановить.

### 3. Volumes

### 4. Сеть

### 5. Создание образов
