# Экзаменационное задание

# 1.

Создайте виртуальную машину для настройки из `debian-template`. Подключите к `vmbr15+X` и настройте ip адрес. К машине должна быть возможность подключиться по ssh с узла `studX`. Добавьте два жестких диска в конфигурацию оборудования размером 0.5 ГБ. Создайте снепшот.

# 2.

Напишите Ansible Playbook, который на созданной виртуальной машине:
- устанавливает время таймаута меню загрузки равным 1 секунде,
- устанавливает selinux и активирует его в режиме `permissive`,
- создаёт и монтирует на постоянной основе raid1 в `/var/lib/postgresql/` с помощью пакета `mdadm`,
- устанавливает в систему PostgreSQL данные которой будут храниться на raid1.

Playbook должен выполнять все пункты конфигурации машины для состояния зафиксированного снепшотом.

# 3.

Зайдите в сконфигурированную машину под пользователем `postgres`. Импортируйте данные в БД, запустив скрипт `weather.sql` из задания `05_sql_postgresql`.

Напишите и выполните sql запрос, который выводит все события из таблицы `weather` за август 2011 года.


### Оценка

За каждый пункт будет засчитывать балл.
1. Настроено время таймаута меню загрузки в 1 секунду.
2. Установлен и активирован selinux в режиме Permissive.
3. Создан и примонтирован mdadm raid1 в `/var/lib/postgresql/`.
4. Установлен PostgreSQL, данные хранятся в raid1, выполняется написанный вами sql запрос из секции задания 3.
5. Написан Ansible Playbook, который настраивает машину из состояния снепшота, как описано в секции ззадания 2.