# Задание 1

Для виртуальных машин `studX-net1` и `studX-net2` настройте статический адрес в помощью `systemd` в подсети `192.168.0.0/24`. Используйте команду `networkctl` и файлы настроек `/etc/systemd/network/ens18.network`. Проверьте, что машины видят друг друга с помощью команды `ping IP-адрес-соседней-машины`.

0. Узнайте статус сервиса `systemd-networkd`.
```
# systemctl status systemd-networkd
```

1. Активируйте `systemd-networkd`, если он не активирован (disabled).
```
# systemctl enable systemd-networkd
```

2. Запустите `systemd-networkd`, если он не запущен (inactive, dead).
```
# systemctl start systemd-networkd
```

3. Определите имя настраиваемого интерфейса.
```
# ip link
```

4. Для настройки интерфейса `ens18` машин `stud1-net1` и `stud1-net2` создайте или отредактируйте в каждой `/etc/systemd/network/ens18.network`.

конфигурация `ens18.network` машины `stud1-net1`
```
[Match]
Name=ens18

[Network]
Address=192.168.0.2/24
```

конфигурация `ens18.network` машины `stud1-net2`
```
[Match]
Name=ens18

[Network]
Address=192.168.0.3/24
```

5. Перечитайте конфигурацию сети на обеих машинах.
```
# networkctl reload
```

6. После конфигурации на обеих машинах проверьте их взаимную доступность по сети.
```
stud@stud1-net1$ ping 192.168.0.3 
stud@stud1-net2$ ping 192.168.0.2 
```

7. В случае проблемы, проверьте, что `systemd-networkd` запущен и в его логах нет ошибок.
```
# systemctl status systemd-networkd
```